using System;
using System.Threading;
using System.Diagnostics;

namespace SimpleSemaphore
{
    class Program
    {
        static Semaphore semaphore;

        static void Main(string[] args)
        {
            semaphore = new Semaphore(2, 2);

            for (int i = 1; i < 10; i++)
            {
                Thread t = new Thread(MyThread);
                t.Start(i);
                Thread.Sleep(1000);
            }
            while (true) ;
        }

        private static void MyThread(object o)
        {
            int i = (int)o;

            if (semaphore.WaitOne(0, false) == false)
            {
                Debug.Print(i.ToString() + ": Cannot start.");
                return;
            }
            Debug.Print(i.ToString() + ": Sleep start.");
            Thread.Sleep(2200);
            Debug.Print(i.ToString() + ": Sleep end.");
            semaphore.Release();
        }
    }
}
